#include "Xbp.ch"
#include "Appevent.ch"

PROCEDURE Main
LOCAL oMain    := SetAppWindow()
LOCAL nEvent   := 0
LOCAL mp1      := NIL
LOCAL mp2      := NIL
LOCAL oXbp     := NIL
LOCAL lExit    := .F.

   CLS

   oMain:Close := {|uNIL1, uNIL2, oSelf| lExit := .T. }
   oMain:mouseMode := XBPCRT_MOUSEMODE_VIO
   SETMOUSE( .T. )

   MausFKeys(oMain)

   DO WHILE !lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp, 0 )
      IF nEvent == xbeK_ESC         // Esc bricht ab
         EXIT

      ELSEIF nEvent < xbeB_Event    // Ausgabe im Crt "Fenster"
         @ 0,0 SAY ""
         @ 0,0 SAY "Die Taste hat den Ereigniscode:"+STR(nEvent)

      ELSEIF oXbp <> NIL
         oXbp:handleEvent( nEvent, mp1, mp2, oXbp )
      ENDIF
   ENDDO

RETURN

Procedure MausFKeys(oCrt)
LOCAL aSize := oCrt:CurrentSize()
LOCAL nWide
LOCAL i

   SetAppWindow( oCrt )

   // try to use Mouse Position in VIO Mode
   oCrt:autoMark := .F.
   oCrt:lbDown := {| aPos, uNIL, oSelf | CheckPos(aPos, oCrt) }

   nWide    := INT(ROUND(Maxcol()/12,0))
   FOR i = 1 TO 12
      SetAppWindow( oCrt )
      @maxrow(),nWide*(i-1) SAY "F"+LTRIM(STR(i))
   NEXT

RETURN

PROCEDURE CheckPos(aPos, oCrt)
LOCAL nRow
LOCAL nCol
LOCAL nWide
LOCAL bBlock
LOCAL nKey

   SetAppWindow( oCrt )

   nWide := INT(ROUND(Maxcol()/12,0))
   nRow  := aPos[1]
   nCol  := aPos[2]
   nKey  := INT(ROUND(nCol/nWide,0))+1

   IF nRow = MaxRow()
      // F12
      IF nKey = 12
         bBlock := {|| StartGUI(oCrt) }
      ELSE
         bBlock := {|| Msgbox("F-Key "+LTRIM(STR(nKey)),oCrt:title)}
      ENDIF
      EVAL(bBlock)
   ENDIF

RETURN

PROCEDURE StartGUI(oCrt)
STATIC oThread := NIL

   IF oThread <> NIL
      IF oThread:active
         // do not run PROCEDURE twice
      ELSE
         oThread:start( "GuiDialog",oThread,oCrt )
      ENDIF

   ELSE
      oThread := Thread() :new()
      oThread:start( "GuiDialog",oThread,oCrt )
   ENDIF

RETURN

PROCEDURE GuiDialog(oThread,oCrt)
LOCAL aSize    := oCrt:Currentsize()
LOCAL nEvent   := 0
LOCAL mp1      := NIL
LOCAL mp2      := NIL
LOCAL oXbp     := NIL
LOCAL oDraw
LOCAL nWide
LOCAL i

   aSize[1] -= 2*4                               // Border
   aSize[2] -= 2*3                               // Border

   oDraw := XbpDialog():new( oCrt, oCrt, {0,0},aSize,,.F.)
   oDraw:title := "GUI Dialog"
   oDraw:Close := {|uNIL1, uNIL2, oSelf| oSelf:Destroy() }
   oDraw:create()

   nWide := INT(ROUND(aSize[1]/12,0))
   FOR i = 1 TO 11
      oXbp := XbpPushButton():new(oDraw:DrawingArea, , {nWide*(i-1),0}, {nWide,20} )
      oXbp:caption := "F"+LTRIM(STR(i))
      oXbp:create()
      oXbp:activate:= {|uNIL1, uNIL2, oSelf | Msgbox( oSelf:caption ) }
   NEXT
   // i ist bei 12
   oXbp := XbpPushButton():new(oDraw:DrawingArea, , {nWide*(i-1),0}, {nWide,20} )
   oXbp:caption := "Exit"
   oXbp:create()
   oXbp:activate:= {|uNIL1, uNIL2, oSelf | PostAppEvent(xbeP_Close,,, oDraw) }

   oDraw:Show()

   DO WHILE nEvent <> xbeP_Close
     nEvent := AppEvent( @mp1, @mp2, @oXbp )
     oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

   oThread:setInterval(NIL)
   oThread := NIL

   SetAppWindow( oCrt )

RETURN

*
*
*